import Taro, { Component } from '@tarojs/taro'
import { View } from '@tarojs/components'

import { AtTabBar } from 'taro-ui'

import './bottomNav.scss'

class bottomNav extends Component {

    config = {
        navigationBarTitleText: 'bottomNav'
    }
    constructor() {
        super(...arguments);

        this.state = {
            current: 0,
            otherData: [
                { name: '首页', url: '/pages/home/home' },
                { name: '商品发布', url: '/pages/goodsPublish/goodsPublish' },
                { name: '供求发布', url: '/pages/supplyDemandPublish/supplyDemandPublish' },
                { name: '我的供求', url: '/pages/mySupplyDemand/mySupplyDemand' },
                { name: '我的需求', url: '/pages/myNeeds/myNeeds' },
            ]
        }

    }
    handleClick(value) {

        this.setState({
            current: value
        })

        let path = this.state.otherData[value].url
        Taro.navigateTo({
            url: path,
        })

    }
   

    componentWillReceiveProps(nextProps) {
        //console.log(this.props, nextProps)
    }

    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {

        const otherDataElementsArray = this.state.otherData.map((item) => {
            return { title: item.name, iconType: 'clock' }
        })
        return (
            <View >
                <AtTabBar className='bottom-nav'
                    fixed
                    fontSize='10'
                    iconSize='18'
                    selectedColor='#FF7142'
                    tabList={
                        otherDataElementsArray
                    }
                    onClick={this.handleClick.bind(this)}
                    current={this.state.current}
                />
            </View>

        )
    }
}

export default bottomNav

