import Taro, { Component } from '@tarojs/taro'
import { View, Image, Text } from '@tarojs/components'

import eyeIcon from '../../icons/eye.png'
import cartIcon from '../../icons/cart.png'
import errorImg from '../../assets/img/errorimg.png'


import './shopItemComponent.scss'
import URL from '../../serviceAPI.config'

class ShopItem extends Component {
// errorImg:'this.src="' + require('@/assets/images/errorimg.png') + '"'   ,  //错误图片显示路径

    constructor() {
        super(...arguments)
        this.state = {
            
    }}

    shopOnClickHanlder(){
        let goodId=this.props.item.goods_id
        Taro.navigateTo({
            url: '/pages/goods/goods?id='+goodId
        })
    }
    componentDidMount(){
        
    }

    // 当图片无效的时候 的方法 （为什么不起作用？？）
    onError(e){
  
        e.target.onerror = null;
      e.target.src = 'https://raw.githubusercontent.com/shenghy/SmileVue/master/src/assets/images/errorimg.png'
    }
    
    render() {
        const imgURL =this.props.item? URL.Base +this.props.item.goods_url:null
        const newPrice = this.props.item ? this.props.item.goods_price : null
        const oldPrice = this.props.item ? this.props.item.goods_org_price : null
        const name = this.props.item ? this.props.item.goods_name : null
        const browseTimes = this.props.item ? this.props.item.browse_times : null
        const goodType = this.props.item ? this.props.item.goods_type_name:null
        return (
            <View className='shopitem-box' onClick={this.shopOnClickHanlder.bind(this)}>
                <View className='goods-type'>
                    {goodType}                
                </View>
                <View className='image-box'>
                    <Image mode='aspectFit' style=' max-height: 100%; max-width: 100%;' alt={name} className='img' src={imgURL} onError={this.onError.bind(this)} />
                </View>
                <View className='price-box'>
                    <Text class='new-price'>￥{newPrice+'  '}</Text>
                    <Text className='old-price'>   ￥{oldPrice}</Text>

                </View>
                <View className='itemname-box'>
                    <View className='name'>{name}</View>
                </View>

                <View className='addon-box'>
                    <View className='basket'>
                        <Image src={cartIcon} style='width:12px; height:12px;vertical-align:middle;'/>
                        <Text className='amount'>0</Text> 
                    </View>
                    |
                    <View className='browse-time'>
                        <Image src={eyeIcon} style='width:12px; height:12px;vertical-align:middle;' />
                        <Text className='amount' >{browseTimes}</Text> 
                    </View>
                </View>
                
            </View>
        )
    }
}

export default ShopItem
