

import Taro, { Component } from '@tarojs/taro'
import { View, Text } from '@tarojs/components'

import { AtTabBar, Picker, AtButton } from 'taro-ui'

import './shopTypeInteractionComp.scss'

class ShopTypeInteractionComp extends Component {

    config = {
        navigationBarTitleText: 'shopTypeInteractionComp'
    }
    constructor() {
        super(...arguments);

        this.state = {
            ///---行业分类 开始
            objectMultiArray: [[{}],[{name:'选择店铺分类',id:''}]],
            multiIndex: [0, 0],
            formatInWindow: [],
            ///---行业分类 结束

        }

    }
    // 店铺分类筛选列表GetShopTypeList
    getShopTypeList(url) {
        Taro.request({
            url: url,
            method: 'POST',
            dataType: 'json',
            data: {
                id: Taro.getStorageSync('shopInfo').shop_id
            },
            header: {
                'content-type': 'application/x-www-form-urlencoded',
                'Cookie': 'PFWSSS=' + Taro.getStorageSync('session_id'),
                'X-Requested-With': 'XMLHttpRequest'
            }
        })
            .then(res => {
                console.log('店铺分类目录', res)
                 this.formatIndustryType(res.data.data)
                this.formatIndustTypeInit(res.data.data)

            }
            )
            .catch(error => {
                console.log('店铺分类请求错误', error)
            })
    }
    // 第一种formate 用于底部弹层滚动时的数据
    formatIndustryType(data) {
        const newIndustryType = []
        if (Object.keys(data).length) {
            for (let key in data) {
                let outterObject = { name: data[key].n, id: '', child: [] }
                if (data[key].c.length) {
                    for (let child of data[key].c) {
                        outterObject.child.push({ name: child.n, id: child.id })
                    }
                } else {
                    outterObject.child.push({ name: '', id: '' })
                }
                newIndustryType.push(outterObject)
            }
        } else {
            console.log('店铺分类数据问题')
        }

        this.setState({ formatInWindow: newIndustryType },()=>{
            console.log('滚动时的数据',this.state.formatInWindow)
        })
    }
    //第二种format 用于底部弹层的初始化数据
    formatIndustTypeInit(data) {
        const firstArray = []
        const secondArray = []
        if (Object.keys(data).length) {

            for (let key in data) {
                firstArray.push({ name: data[key].n, id: '' })
                if (data[key].c.length) {
                    for (let child of data[key].c) {
                        secondArray.push({ name: child.n, id: child.id })
                    }
                }
            }

        } else {
            console.log('店铺分类数据问题')
        }

        this.setState({ objectMultiArray: [firstArray, secondArray] }, () => {
          //  console.log('初始化数据', this.state.objectMultiArray)
        })

    }
    //--------------------开始-行业分类picker
    bindMultiPickerChange(e) {
       

      //  console.log('picker发送选择改变，携带值为', e.detail.value)

        this.setState({
            multiIndex: e.detail.value,
        }, () => {
             //判断如果formatInWindow 的子类为空 那就取父类， 反之取子类
        let industryTypeSelected
        if (this.state.formatInWindow[e.detail.value[0]].child[e.detail.value[1]].id === '') {
            industryTypeSelected = this.state.formatInWindow[e.detail.value[0]]
        } else {
            industryTypeSelected = this.state.formatInWindow[e.detail.value[0]].child[e.detail.value[1]]
        }
            this.passDataToParent(industryTypeSelected)
        })

    }
    bindMulPickerColChge(e) {
//console.log('修改的列为', e.detail.column, '，值为', e.detail.value)
        const data = {
            objectMultiArray: this.state.objectMultiArray,
            multiIndex: this.state.multiIndex
        }
     //   console.log(' this.state.formatInWindow', this.state.formatInWindow)
        data.multiIndex[e.detail.column] = e.detail.value

        switch (e.detail.column) {
            case 0:
                switch (data.multiIndex[0]) {
                    case 0:
                        data.objectMultiArray[1] = this.state.formatInWindow[0].child
                        break
                    case 1:
                        data.objectMultiArray[1] = this.state.formatInWindow[1].child
                        break
                    case 2:
                        data.objectMultiArray[1] = this.state.formatInWindow[2].child
                        break
                    case 3:
                        data.objectMultiArray[1] = this.state.formatInWindow[3].child
                        break
                    case 4:
                        data.objectMultiArray[1] = this.state.formatInWindow[4].child
                        break
                    case 5:
                        data.objectMultiArray[1] = [{ name: '' }]
                        break
                    case 6:
                        data.objectMultiArray[1] = this.state.formatInWindow[6].child
                        break
                    case 7:
                        data.objectMultiArray[1] = this.state.formatInWindow[7].child
                        break
                    case 8:
                        data.objectMultiArray[1] = this.state.formatInWindow[8].child
                        break
                    case 9:
                        data.objectMultiArray[1] = this.state.formatInWindow[9].child
                        break
                    case 10:
                        data.objectMultiArray[1] = this.state.formatInWindow[10].child
                        break
                    case 11:
                        data.objectMultiArray[1] = this.state.formatInWindow[11].child
                        break
                    case 12:
                        data.objectMultiArray[1] = this.state.formatInWindow[12].child
                        break
                    case 13:
                        data.objectMultiArray[1] = this.state.formatInWindow[13].child
                        break
                    case 14:
                        data.objectMultiArray[1] = this.state.formatInWindow[14].child
                        break
                }
                data.multiIndex[1] = 0
                break

        }
      //  console.log(data.multiIndex)
      //  console.log('objectMultiArray', data.objectMultiArray)
        this.setState({
            multiIndex: data.multiIndex,
            objectMultiArray: data.objectMultiArray
        }, () => {

        })
    }

    //--------------------结束-行业分类picker
    passDataToParent(industryTypeSelected) {
        this.props.onPassDataToChild(industryTypeSelected)
    }
    

    componentDidMount() {
        this.getShopTypeList(this.props.url)
        
    }
    // 当然父组件有新的props的 会从新渲染组件
    componentWillReceiveProps(nextProps) {

    }
    componentWillUnmount() { }

    componentDidShow() { }

    componentDidHide() { }

    render() {
        return (
            <View class='page-section'>
                <Picker
                    rangeKey='name'
                    mode='multiSelector'
                    onChange={this.bindMultiPickerChange.bind(this)}
                    onColumnchange={this.bindMulPickerColChge.bind(this)}
                    value={this.state.multiIndex}
                    range={this.state.objectMultiArray}
                >
                    <View class='picker type'>
                        <View className='title-box'>
                        <Text className='require'>*</Text>
                            <Text className='title'>店铺分类：</Text>
                            <Text className='first-col'>
                            {this.props.selectedValue.name}
                            </Text>
                        </View>
                    </View>
                </Picker>
            </View>


        )
    }
}

export default ShopTypeInteractionComp


